#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>

unsigned char far * vga = (unsigned char far * ) MK_FP(0xa000,0);

//const int screen_left = 0;
//const int screen_right = 320;
//const int screen_top = 10;
//const int screen_bottom = 190;


#include "sprite.h"
#include "bullet.h"
#include "powerup.h"
#include "ship.h"
#include "enemy.h"
#include "player.h"

extern char *temp_string;
extern char *Hi_score_string;
extern int Hi_score_string_len;
extern long hi_score;

Player::Player(Sprite* bm, Sprite* expl, Sprite *bullt, int start_x, int start_y)
{
			bitmap = bm; explosion = expl; bullet = bullt;
			x = start_x; y = start_y;
			bullets = NULL;
			state = 1;
			lives = 5;
			score = 0;
			min_charge = 15;
			max_charge = 40;
			shield_recharge_level = 40;
			min_shield = 0;
			max_shield = 40;
			charge = max_charge;
			shield = max_shield;
			gun_type = 1;
			fire_power[0] = 0;
			fire_power[1] = 3;
			fire_power[2] = 2;
			fire_power[3] = 2;
			fire_power[4] = 3;

			max_fire_power = 4;
			recharge_rate = 1;
			recharge_shield_rate = 1;
		}

int
Player::collected( PowerUp *powerUps)
{
	int px, py;

	if(state == 0)		// inactive
		return 0;

	px = powerUps->x;
	py = powerUps->y;
	if(px>=x && py>=y && px<=(x+bitmap->sx) && py<=(y+bitmap->sy) )
		return 1;

	px = powerUps->x + powerUps->bitmap->sx;
	py = powerUps->y;
	if(px>=x && py>=y && px<=(x+bitmap->sx) && py<=(y+bitmap->sy) )
		return 1;

	px = powerUps->x + powerUps->bitmap->sx;
	py = powerUps->y + powerUps->bitmap->sy;
	if(px>=x && py>=y && px<=(x+bitmap->sx) && py<=(y+bitmap->sy) )
		return 1;

	px = powerUps->x;
	py = powerUps->y + powerUps->bitmap->sy;
	if(px>=x && py>=y && px<=(x+bitmap->sx) && py<=(y+bitmap->sy) )
		return 1;

	return 0;
}


void Player::update(Enemy *enemy , int num_enemies, byte *screen)
{
	Bullet *temp, *last, *current;
	int x, y, i;
	int deleted = 0;

	draw(screen);

	if(state==2)		// exploding
		state = 0;

	last = current = bullets;
	while(current)
	{
		deleted = 0;		// set flag to know if bullet has been
								// removed from list
		current->draw(screen);
		current->move();

			// off screen?
		if(current->y < screen_top)		// remove bullet from list
		{
			if(bullets == current) 	// first in list
			{
				bullets = current->next;

			} else
			{
				last->next = current->next;
			}
			temp = current;
			current = current->next;
			delete  temp ;

				// last stays the same

			deleted = 1;
			continue;		// skip to end of while loop - don't check for
								// collisions with enemies
		} else
		{

			for(i=0;i<num_enemies;i++)
			{
				if(enemy[i].isHit(current))
				{
					if((--enemy[i].hits) <= 0)
					{
						enemy[i].state=2;
//						enemy[i].x -= (enemy[i].explosion->sx - enemy[i].bitmap->sx)/2;
//						enemy[i].y -= (enemy[i].explosion->sy - enemy[i].bitmap->sy)/2;

					}

					bullet_explosion->draw(current->x + current->bitmap->sx/2 - bullet_explosion->sx/2,
														  current->y + current->bitmap->sy/2 - bullet_explosion->sy/2,
														  screen);


							// remove bullet from list
					if(bullets == current) 	// first in list
					{
						bullets = current->next;
					} else
					{
						last->next = current->next;
					}

					temp = current;
					current = current->next;
					delete temp ;
					deleted = 1;
					break;		// stop for loop incase bullet hits two enemies
										// at once

				}
			}
		}
			// get next bullet
		if(!deleted)
		{
			last = current;
			current= current->next;
		}
	}

	charge+=recharge_rate;

	if(charge > max_charge)
	{
		charge = max_charge;
	}

	if( charge>=shield_recharge_level)
	{
		shield+=recharge_shield_rate;
		if(shield > max_shield) shield = max_shield;
	}
}

int Player::getInput(Sprite &city, Sprite &city_backup, Sprite &player_bullet,
							Enemy * enemy, int num_enemies, Sprite &font, byte *screen)
{

	static const char cheatstring[] ={ "tom" };
	static int cheat = 0;

	Bullet *temp, *current;
	int i;
	int mouse_x, mouse_y;
	int button;
	char ch;

		// read mouse position & buttons
	asm mov ax, 3
	asm int 33h
	asm mov word ptr button, bx

	asm mov word ptr mouse_x, cx
	asm mov word ptr mouse_y, dx

	if(state==1)
	{
		x = mouse_x/2;
		if(x>(319 - bitmap->sx) ) x = 319 - bitmap->sx;


		if((button&1) && charge>min_charge)	// fire
		{
			charge -= fire_power[gun_type];
			if(charge<0) charge = 0;


			switch(gun_type)
			{
				default:
				case 4:
					temp = new Bullet(x, y-player_bullet.sy, -3, -10, &player_bullet);

					if(temp)
					{
						temp->next = bullets;
						bullets = temp;
					}

					temp = new Bullet(x + bitmap->sx - player_bullet.sx,
										  y-player_bullet.sy, 3, -10, &player_bullet);

					if(temp)
					{
						temp->next = bullets;
						bullets = temp;
					}

					temp = new Bullet(x + bitmap->sx/2, y-player_bullet.sy, 0, -10, &player_bullet);

					if(temp)
					{
						temp->next = bullets;
						bullets = temp;
					}
					break;
				case 3:
					temp = new Bullet(x, y-player_bullet.sy, 0, -10, &player_bullet);

					if(temp)
					{
						temp->next = bullets;
						bullets = temp;
					}

					temp = new Bullet(x + bitmap->sx - player_bullet.sx,
										  y-player_bullet.sy, 0, -10, &player_bullet);

					if(temp)
					{
						temp->next = bullets;
						bullets = temp;
					}
					break;
				case 2:
					temp = new Bullet(x+bitmap->sx/2, y-player_bullet.sy, 0, -15, &player_bullet);

					if(temp)
					{
						temp->next = bullets;
						bullets = temp;
					}
					break;
				case 1:
					temp = new Bullet(x+bitmap->sx/2, y-player_bullet.sy, 0, -10, &player_bullet);

					if(temp)
					{
						temp->next = bullets;
						bullets = temp;
					}
					break;
				case 0:
					break;
			}
		}
	}
	else if(state==0)
	{
		if(lives==1)
		{
			gputs(16,9,"Game Over", font, screen);

			for(i=0;i<num_enemies;i++)
				enemy[i].fire_rate = -1;

		}

		gputs(11,11,"Press Right Button", font, screen);

		if(button&2)
		{
			if(lives==1)
			{


				for(i=0;i<num_enemies;i++)
				{
					current = enemy[i].bullets;

					enemy[i].bullets=NULL;

					while(current)
					{
						temp = current;
						current = current->next;

						delete temp;
					}
				}


				return 2;

			} else
			{
				lives --;
				gun_type = 1;
				min_charge = 15;
				max_charge = 40;
				min_shield = 0;
				max_shield = 40;
				recharge_rate = 1;
				recharge_shield_rate = 1;
				x += explosion->sx/2;
			}

			memcpy(city.bitmap, city_backup.bitmap, city.sx*city.sy);
//			if(city.bitmap) delete [] city.bitmap;
//			city.bitmap = loadSprite( "newmelb.vga", city.sx, city.sy);

			state=1;
			shield = max_shield;
			charge = max_charge;

				// move mouse back to where player died
			mouse_x = x * 2;

			asm mov ax, 4
			asm mov cx, word ptr mouse_x
			asm mov dx, 100
			asm int 33h
		}
	}

	if(kbhit())
	{
		ch = getch();

		if(ch==cheatstring[cheat])
		{
			cheat++;
			if(cheat==3)
			{
				gun_type = max_fire_power;

				max_shield = 75;
				max_charge = 75;

				shield = max_shield;
				charge = max_charge;

				lives = 5;

				cheat = 0;
			}

		}
		else
			cheat = 0;

		switch(ch)
		{

			case 'p':
				gputs(15,11,"Press A Key", font, vga);
				getch();
				break;
			case '`':
				gun_type++;
				if(gun_type>max_fire_power) gun_type=max_fire_power;
				break;
			case 27:
				gputs(3,11,"Are You Sure You Want To Quit? (y/n)", font, vga);
				ch = getch();
				if(ch=='y' || ch=='Y')
					return 1;
			default:
				break;
		}
	}

	return 0;
}

void
Player::DrawStatus(Sprite &font, byte *screen)
{
	gputs(0,0,"Power:",font,screen);

	{
		int x;

		for(x=50;x<(50+charge);x++)
		{
			putPixel(x,2,13,screen);
			putPixel(x,3,13,screen);
			putPixel(x,4,13,screen);
			putPixel(x,5,13,screen);
		}
		putPixel(50 + max_charge, 2,15,screen);
		putPixel(50 + max_charge, 3,15,screen);
		putPixel(50 + max_charge, 4,15,screen);
		putPixel(50 + max_charge, 5,15,screen);
		putPixel(50 + min_charge, 2,4,screen);
		putPixel(50 + min_charge, 3,4,screen);
		putPixel(50 + min_charge, 4,4,screen);
		putPixel(50 + min_charge, 5,4,screen);
	}

	gputs(20,0,"Shields:",font,screen);

	{
		int x;

		for(x=232;x<(232+shield);x++)
		{
			putPixel(x,2,12,screen);
			putPixel(x,3,12,screen);
			putPixel(x,4,12,screen);
			putPixel(x,5,12,screen);
		}
		putPixel(232 + max_shield, 2,15,screen);
		putPixel(232 + max_shield, 3,15,screen);
		putPixel(232 + max_shield, 4,15,screen);
		putPixel(232 + max_shield, 5,15,screen);
	}

	gputs(0,24,"Lives:",font,screen);
	gputs( 6, 24, itoa(lives, temp_string, 10), font,screen);
	gputs(15,24,"Score:",font,screen);
	gputs( 21, 24, itoa(score, temp_string, 10), font,screen);
	gputs( 79 - Hi_score_string_len, 24, Hi_score_string, font,screen);


}
